Cow Relays (优先队列+bfs)

题目链接:oj22854

题目:

 

题意:给出N个点,M条无向边,让你从中找出k条从源点1到终点N的最短路,可以重复走某个点(假设满足最短距离最小的话),

最后问:走完k条最短路,总距离是多少?

题解:刚开始用了优先队列加最短路,wa了。

看完标程加niubi队友讲解,其实就是个优先队列加bfs。

代码写的很暴力,但不加剪枝的话,爆内存。

我们可以这样剪枝,当某一点走的次数大于k次,说明此路径一定不是最优的。为什么呢?

1,我们可以先这样假设,存在一条最短路(min)是最小的,并且满足以后的k-1条"最短路"都在这条最短路(min)上的某一条边往返,那么此时某一点是不是最多走k次

2,我们再假设,存在一条最短路(min)是最小的,并且以后的k-1条"最短路"不一定都在这条最短路(min)上的某一条边往返,那么此时,任何一个点都不能走k次,因为会被其它更短的路径给替代了。

 

#include<cstdio>
#include<algorithm>
#include<cstring>
#include<vector>
#include<queue>

using namespace std;

struct node{
    int v,edge;
};
vector<node> G[900];

struct NODE{
    int val;///到达此点的价值
    int index;///点
    bool operator < (const NODE &a) const{
        return val>a.val;///优先队列按小顶堆排
    }
};

priority_queue<NODE> que;

int book[900];

int main()
{
    memset(book,0,sizeof(book));
    int k,n,m;
    scanf("%d%d%d",&k,&n,&m);

    int num=k;
    for(int i=1;i<=m;i++)
    {
        int s,t,w;
        scanf("%d%d%d",&s,&t,&w);
        G[s].push_back({t,w});
        G[t].push_back({s,w});
    }

    int ans=0;
    que.push({0,1});///先放入价值为0,顶点为1
    while(!que.empty())
    {
        NODE item=que.top();
        que.pop();

        ///剪枝
        book[item.index]++;///到达此点后++
        if(book[item.index]>num) continue;///如果某一点走的次数大于k次,说明此路径不满足最优
        if(item.index==n){///到达终点
            ans+=item.val;
            k--;
            continue;
        }
        if(!k) break;

        int len=G[item.index].size();
        for(int i=0;i<len;i++){///push与item.index的邻接点
            NODE t;
            t.val=item.val+G[item.index][i].edge;
            t.index=G[item.index][i].v;
            que.push(t);
        }
    }

    printf("%d\n",ans);
    return 0;
}

 

 

我的标签:做个有情怀的程序员。

 

 

 

 

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
Description The cow bicycling team consists of N (1 <= N <= 20) cyclists. They wish to determine a race strategy which will get one of them across the finish line as fast as possible. Like everyone else, cows race bicycles in packs because that's the most efficient way to beat the wind. While travelling at x laps/minute (x is always an integer), the head of the pack expends x*x energy/minute while the rest of pack drafts behind him using only x energy/minute. Switching leaders requires no time though can only happen after an integer number of minutes. Of course, cows can drop out of the race at any time. The cows have entered a race D (1 <= D <= 100) laps long. Each cow has the same initial energy, E (1 <= E <= 100). What is the fastest possible finishing time? Only one cow has to cross the line. The finish time is an integer. Overshooting the line during some minute is no different than barely reaching it at the beginning of the next minute (though the cow must have the energy left to cycle the entire minute). N, D, and E are integers. Input A single line with three integers: N, E, and D Output A single line with the integer that is the fastest possible finishing time for the fastest possible cow. Output 0 if the cows are not strong enough to finish the race. Sample Input 3 30 20 Sample Output 7 Hint as shown in this chart: leader E pack total used this time---leader--speed--dist---minute 1------1-------5------5------25 2------1-------2------7-------4 3------2*------4------11-----16 4------2-------2------13------4 5------3*------3------16------9 6------3-------2------18------4 7------3-------2------20------4 * = leader switch Source USACO 2002 February

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值